function ssoServer(port,clientDomain,clientTokenName,caseDomain) {
    var express = require('express')
    var ConnectCas = require('./connect-cas2/index');
    var bodyParser = require('body-parser');
    var session = require('express-session');
    var cookieParser = require('cookie-parser');
    var MemoryStore = require('session-memory-store')(session);
    var app = express()
    app.use(cookieParser());
    app.use(session({
        name: 'NSESSIONID',
        secret: 'Hello I am a long long long secret',
        store: new MemoryStore(),  // or other session store
        resave:false,//强制保存session,即使它没变化
        saveUninitialized:true //强制将未初始化的session存储，默认为true
    }));
    var casClient = new ConnectCas({
        debug: true,
        ignore: [
            /\/ignore/
        ],
        match: [],
        servicePrefix: clientDomain,
        serverPath: caseDomain,
        paths: {
            validate: '/cas/validate',
            serviceValidate: '/cas/p3/serviceValidate',
            proxy:'',
            proxyCallback:'',
            login: '/cas/login',
            logout: '/cas/logout',

        },

        rejectUnauthorized:false,
        restletIntegration:false,
        gateway: false,
        renew: false,
        slo: true,
        cache: {
            enable: false,
            ttl: 5 * 60 * 1000,
            filter: []
        },
        fromAjax: {
            header: 'x-client-ajax',
            status: 418
        }
    });
    app.use(casClient.core());
// NOTICE: If you want to enable single sign logout, you must use casClient middleware before bodyParser.
    app.use(bodyParser.json());
    app.use(bodyParser.urlencoded({ extended: true }));
    var http = require('http').Server(app)
    var path = require('path');
    app.set('views', path.join(__dirname, '../../dist'));
    app.set('view engine', 'ejs');
    app.use(express.static(path.join(__dirname, '../../dist')));
    var InfraToken = false
    app.get('/*', function(req, res, next) {
        if(req.url !== '/logout'){
            console.log('服务端数据case',req.session.cas)
            res.setHeader('Set-Cookie', clientTokenName + '=' + req.session.cas.attributes.m8msdp_token[0]);
            if(!InfraToken){
                res.render('index')
            }else {
                res.render('index')
            }
        }else { //登出
            // Do whatever you like here, then call the logout middleware
            casClient.logout()(req, res, next);
        }
    })
    if (process.env.PORT) {
        console.log('> Listening at ' + process.env.PORT + '\n')
        http.listen(process.env.PORT)
    } else {
        http.listen(port)
        console.log('> Listening at ' + port + '\n')
    }
}
module.exports = ssoServer;
